(* general cardinal arithmetics, solyga@gmx.de 2022-10-06 *)
IMPLEMENTATION MODULE GCA;


PROCEDURE Inc0( VAR x: TDigit; VAR c: BOOLEAN );
BEGIN
  IF x < MAX( TDigit ) THEN
    INC( x );
  ELSE
    x := 0;
    c := TRUE;
  END;
END Inc0;

PROCEDURE IncD( VAR x: TDigit; y: TDigit; VAR c: BOOLEAN );
BEGIN
  IF c THEN c := FALSE; Inc0( x, c ) END;
  WHILE y > 0 DO Inc0( x, c ); DEC( y ) END;
END IncD;

PROCEDURE Dec0( VAR x: TDigit; VAR c: BOOLEAN );
BEGIN
  IF x > 0 THEN
    DEC( x );
  ELSE
    x := MAX( TDigit );
    c := TRUE;
  END;
END Dec0;

PROCEDURE DecD( VAR x: TDigit; y: TDigit; VAR c: BOOLEAN );
BEGIN
  IF c THEN c := FALSE; Dec0( x, c ) END;
  WHILE y > 0 DO Inc0( x, c ); DEC( y ) END;
END DecD;


PROCEDURE Len0( x-: TNumber ): CARDINAL;
VAR
  l: CARDINAL;
BEGIN
  l := SIZE( x );
  WHILE ( l > 0 ) & ( x[l-1] = 0 ) DO DEC( l ) END;
  RETURN l;
END Len0;



PROCEDURE Inc( VAR x: TNumber; y-: TNumber ): BOOLEAN;
VAR
  i, l: CARDINAL;
  c: BOOLEAN;
BEGIN
  i := 0; l := Len0( y ); c := FALSE;
  WHILE i < l DO
    IF i >= SIZE( x ) THEN RETURN FALSE END;
    IncD( x[i], y[i], c );
    INC( i );
  END;
  WHILE c DO
    IF i >= SIZE( x ) THEN RETURN FALSE END;
    c := FALSE; Inc0( x[i], c );
    INC( i );
  END;
  RETURN TRUE;
END Inc;

PROCEDURE Dec( VAR x: TNumber; y-: TNumber ): BOOLEAN;
VAR
  i, l: CARDINAL;
  c: BOOLEAN;
BEGIN
  i := 0; l := Len0( y ); c := FALSE;
  WHILE i < l DO
    IF i >= SIZE( x ) THEN RETURN FALSE END;
    DecD( x[i], y[i], c );
    INC( i );
  END;
  WHILE c DO
    IF i >= SIZE( x ) THEN RETURN FALSE END;
    c := FALSE; Dec0( x[i], c );
    INC( i );
  END;
  RETURN TRUE;
END Dec;

END GCA.
