(* large cardinals - hexadecimal conversions *)
(* solyga@gmx.de, 2022-11-18 *)
IMPLEMENTATION MODULE LCC0;

FROM SYSTEM IMPORT BYTE;
IMPORT Types, Str;

TYPE
  TSht = Types.TShtCard;


PROCEDURE Digit( c: CHAR ): TSht;
BEGIN
  c := CAP( c );
  CASE c OF
  | '0'..'9': RETURN ORD( c ) - ORD( '0' );
  | 'A'..'Z': RETURN ORD( c ) - ORD( 'A' ) + 10;
  ELSE
    RETURN MAX( TSht );
  END;
END Digit;

PROCEDURE MkCard( VAR x: ARRAY OF BYTE; s-: ARRAY OF CHAR ): BOOLEAN;
VAR
  ok: BOOLEAN;
  l: CARDINAL;

  PROCEDURE Get( VAR x: TSht );
  BEGIN
    IF l > 0 THEN
      DEC( l );
      x := Digit( s[l] );
      IF x >= 10H THEN x := 0; ok := FALSE END;
    ELSE
      x := 0;
    END;
  END Get;

VAR
  i: CARDINAL;
  y, z: TSht;
BEGIN
  ok := TRUE;
  l := Str.Length( s );
  IF l = 0 THEN RETURN FALSE END;
  FOR i := 0 TO SIZE( x ) - 1 DO
    Get( y );
    Get( z );
    x[ i ] := BYTE( y + z * 10H );
  END;
  RETURN ok;
END MkCard;


PROCEDURE Char( x: TSht ): CHAR;
BEGIN
  IF x < 10 THEN
    RETURN CHR( x + ORD('0') );
  ELSE
    RETURN CHR( x - 10 + ORD('A') );
  END;
END Char;

PROCEDURE MkStr( VAR s: ARRAY OF CHAR; x-: ARRAY OF BYTE ): BOOLEAN;
VAR
  ok: BOOLEAN;
  l: CARDINAL;

  PROCEDURE Put( y: TSht );
  BEGIN
    IF ( y = 0 ) & ( l = 0 ) THEN RETURN END;
    IF l >= SIZE( s ) THEN ok := FALSE; RETURN END;
    s[ l ] := Char( y );
    INC( l );
  END Put;

VAR
  i: CARDINAL;
  y: TSht;
BEGIN
  ok := TRUE;
  l := 0;
  FOR i := SIZE( x ) - 1 TO 0 BY -1 DO
    y := x[ i ];
    Put( y DIV 10H );
    Put( y MOD 10H );
  END;
  IF l = 0 THEN s[ 0 ] := '0'; l := 1 END;
  IF l < SIZE( s ) THEN s[ l ] := 0C END;
  RETURN ok;
END MkStr;

END LCC0.
