MODULE LrgCards;

FROM SYSTEM IMPORT BYTE;
IMPORT Types, LC, LCC0, LCC, Config, RNG;
IMPORT IO, Lib, Str;
IMPORT WinBase, Tmr0;
IMPORT Ticks;
IMPORT GCA;


TYPE
  TCard01 = ARRAY [0..0] OF BYTE;
  TCard02 = ARRAY [0..1] OF BYTE;
  TCard03 = ARRAY [0..2] OF BYTE;
  TCard04 = ARRAY [0..3] OF BYTE;
  TCard05 = ARRAY [0..4] OF BYTE;
  TCardMax = ARRAY [0..127] OF BYTE;


CONST
  Now ::= WinBase.GetTickCount;

PROCEDURE Fatal( s-: ARRAY OF CHAR );
BEGIN
  IO.WrLn();
  Lib.FatalError( s );
  HALT;
END Fatal;


PROCEDURE WrHex( x-: ARRAY OF BYTE );
VAR
  s: ARRAY [0..255] OF CHAR;
BEGIN
  IF LCC0.MkStr( s, x ) THEN
    IO.WrStr( s );
  ELSE
    IO.WrStr( '???' );
  END;
END WrHex;

CONST
  WrLn ::= IO.WrLn;
  WrStr ::= IO.WrStr;


PROCEDURE Test00();
VAR i, j: CARDINAL;
BEGIN
  FOR i := 0 TO 2 DO
    IO.WrCard( i, 1 ); IO.WrLn();
  END;
  j := i;
  IO.WrLngCard( j, 1 ); IO.WrLn();
END Test00;

PROCEDURE Test01();

  PROCEDURE Use( x-: ARRAY OF BYTE; i: CARDINAL );
  BEGIN
    <* PUSH *> <* CHECKINDEX - *>
    IO.WrHex( ORD( x[i] ), 3 ); IO.WrLn();
    <* POP *>
  END Use;

VAR
  x: ARRAY [0..1] OF CHAR;
  i: CARDINAL;
BEGIN
  FOR i := 0 TO 2 DO Use( x, i ) END;;
END Test01;

PROCEDURE Test02();

  PROCEDURE Show( x: CARDINAL );
  BEGIN
    IO.WrLngHex( x, 1 ); IO.WrLn();
  END Show;

  PROCEDURE Card( x: Types.TShtCard (* Card, LngCard *) );
  BEGIN
    <* PUSH *> <* COVERFLOW - *>
    DEC( x );
    <* POP *>
    Show( x );
    <* PUSH *> <* COVERFLOW - *>
    INC( x );
    <* POP *>
    Show( x );
    (* now it's getting strange... *)
    <* PUSH *> <* COVERFLOW - *> <* CHECKRANGE - *>
    x := x - 1;
    <* POP *>
    Show( x );
    <* PUSH *> <* COVERFLOW + *> <* CHECKRANGE - *>
    x := x + 1;
    <* POP *>
    Show( x );
  END Card;

BEGIN
  Card( 0 );
END Test02;


PROCEDURE Test10();
VAR
  x: Types.TShtCard;
  y: Types.TCard;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test10: begin' ); IO.WrLn();
  t := Now();

  x := 0CFH;
  y := 11H;
  WrStr( '  INC( ' ); WrHex( x ); WrStr( ', ' ); WrHex( y ); WrStr( ' ) = ' );
  IF ~ LC.Inc( x, y ) THEN Fatal( 'Test10: Inc failed' ) END;
  WrHex( x ); WrLn();

  IO.WrStr( 'Test10: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test10;

PROCEDURE Test11();
VAR
  x: Types.TLngCard;
  y: Types.TLngCard;
  z: TCard05;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test11: begin' ); IO.WrLn();
  t := Now();

  x := 0FFFFEFEFH;
  y := 01111H;
  IF ~ LC.Add( x, y, z ) THEN Fatal( 'Test11: Add failed' ) END;
  WrStr( '  ' ); WrHex( x ); WrStr( ' + ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();

  IO.WrStr( 'Test11: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test11;

PROCEDURE Test20();
VAR
  x, y: Types.TCard;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test20: begin' ); IO.WrLn();
  t := Now();

  x := 0FFFEH;
  y := 0FFH;
  WrStr( '  DEC( ' ); WrHex( x ); WrStr( ', ' ); WrHex( y ); WrStr( ' ) = ' );
  IF ~ LC.Dec( x, y ) THEN Fatal( 'Test20: Dec failed' ) END;
  WrHex( x ); WrLn();

  IO.WrStr( 'Test20: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test20;

PROCEDURE Test21();
VAR
  x: Types.TCard;
  y: Types.TShtCard;
  z: TCard01;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test21: begin' ); IO.WrLn();
  t := Now();

  x := 0100H;
  y := 01H;
  IF ~ LC.Sub( x, y, z ) THEN Fatal( 'Test21: Sub failed' ) END;
  WrStr( '  ' ); WrHex( x ); WrStr( ' - ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();

  IO.WrStr( 'Test21: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test21;

PROCEDURE Test30();
VAR
  x: Types.TCard;
  y: Types.TCard;
  z: TCard03;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test30: begin' ); IO.WrLn();
  t := Now();

  x := 0FFFFH;
  y := 0FFH;
  IF ~ LC.Mul( x, y, z ) THEN Fatal( 'Test30: Mul failed' ) END;
  WrStr( '  ' ); WrHex( x ); WrStr( ' * ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();

  IO.WrStr( 'Test30: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test30;

PROCEDURE Test31();
VAR
  x: Types.TCard;
  y: Types.TCard;
  z: Types.TLngCard;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test31: begin' ); IO.WrLn();
  t := Now();

  FOR x := 0 TO 0FFFFH DO
    IF x MOD 400H = 0 THEN WrHex( x ); WrLn(); END;
    FOR y := 0 TO 0FFFFH DO
      IF ~ LC.Mul( x, y, z ) THEN Fatal( 'Test31: Mul failed' ) END;
      IF z # x * y THEN
        WrStr( ' x = ' ); WrHex( x ); WrLn();
        WrStr( ' y = ' ); WrHex( y ); WrLn();
        WrStr( ' z = ' ); WrHex( z ); WrLn();
        Fatal( 'Test31: Wrong result' );
      END;
    END;
  END;

  IO.WrStr( 'Test31: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test31;

PROCEDURE Test40();
VAR
  x: Types.TLngCard;
  y: Types.TShtCard;
  z: TCard03;
  r: TCard02;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test40: begin' ); IO.WrLn();
  t := Now();

  x := 0FF0001H;
  y := 0FFH;
  IF ~ LC.Div( x, y, z, r ) THEN Fatal( 'Test40: Div failed' ) END;
  WrStr( '  ' ); WrHex( x ); WrStr( ' DIV ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();
  WrStr( '  ' ); WrHex( x ); WrStr( ' MOD ' ); WrHex( y ); WrStr( ' = ' ); WrHex( r ); WrLn();

  IO.WrStr( 'Test40: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test40;

PROCEDURE Test41();
VAR
  x: Types.TLngCard;
  y: Types.TCard;
  z: Types.TLngCard;
  r: Types.TCard;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test41: begin' ); IO.WrLn();
  t := Now();

  FOR x := 0 TO 0FFFFFFFFH DO
    IF x MOD 400H = 0 THEN WrHex( x ); WrLn(); END;
    FOR y := 1 TO 0FFFFH DO
      IF ~ LC.Div( x, y, z, r ) THEN Fatal( 'Test41: Div failed' ) END;
      IF ( z # x DIV y ) OR ( r # x MOD y ) THEN
        WrStr( ' x = ' ); WrHex( x ); WrLn();
        WrStr( ' y = ' ); WrHex( y ); WrLn();
        WrStr( ' z = ' ); WrHex( z ); WrLn();
        WrStr( ' r = ' ); WrHex( r ); WrLn();
        Fatal( 'Test41: Wrong result' );
      END;
    END;
  END;

  IO.WrStr( 'Test41: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test41;


PROCEDURE Test50();
VAR
  x, y: Types.TLngCard;
  s: ARRAY [0..127] OF CHAR;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test50: begin' ); IO.WrLn();
  t := Now();

  x := 12H;
  IF ~ LCC0.MkStr( s, x ) THEN Fatal( 'Test50: MkStr failed' ) END;
  IF ~ LCC.MkCard( y, s, 16 ) THEN Fatal( 'Test50: MkCard failed' ) END;
  IF x # y THEN
    WrStr( ' x = ' ); WrHex( x ); WrLn();
    WrStr( ' s = ' ); WrStr( s ); WrLn();
    WrStr( ' y = ' ); WrHex( y ); WrLn();
    Fatal( 'Test50: Wrong result' );
  END;

  IO.WrStr( 'Test50: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test50;

PROCEDURE Test51();
VAR
  x, y: Types.TLngCard;
  s: ARRAY [0..127] OF CHAR;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test51: begin' ); IO.WrLn();
  t := Now();

  FOR x := 0 TO 0FFFFFFFFH DO
    IF x MOD 10000000H = 0 THEN WrHex( x ); WrLn(); END;
    IF ~ LCC0.MkStr( s, x ) THEN Fatal( 'Test51: MkStr failed' ) END;
    IF ~ LCC0.MkCard( y, s ) THEN Fatal( 'Test51: MkCard failed' ) END;
    IF x # y THEN
      WrStr( ' x = ' ); WrHex( x ); WrLn();
      WrStr( ' s = ' ); WrStr( s ); WrLn();
      WrStr( ' y = ' ); WrHex( y ); WrLn();
      Fatal( 'Test51: Wrong result' );
    END;
  END;

  IO.WrStr( 'Test51: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test51;

PROCEDURE Test52();
VAR
  x, y: Types.TLngCard;
  s: ARRAY [0..127] OF CHAR;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test52: begin' ); IO.WrLn();
  t := Now();

  FOR x := 0 TO 0FFFFFFFFH DO
    IF x MOD 10000000H = 0 THEN WrHex( x ); WrLn(); END;
    IF ~ LCC.MkStr( s, x, 16 ) THEN Fatal( 'Test52: MkStr failed' ) END;
    IF ~ LCC.MkCard( y, s, 16 ) THEN Fatal( 'Test52: MkCard failed' ) END;
    IF x # y THEN
      WrStr( ' x = ' ); WrHex( x ); WrLn();
      WrStr( ' s = ' ); WrStr( s ); WrLn();
      WrStr( ' y = ' ); WrHex( y ); WrLn();
      Fatal( 'Test52: Wrong result' );
    END;
  END;

  IO.WrStr( 'Test52: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test52;

PROCEDURE Test53();
VAR
  x: TCardMax;
  s: ARRAY [0..127] OF CHAR;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test53: begin' ); IO.WrLn();
  t := Now();

  Str.Copy( s, 'a' );
  WrStr( ' s = ' ); WrStr( s ); WrLn();
  WrStr( ' b = ' ); WrHex( Config.data.ba ); WrLn();
  IF ~ LCC.MkCard( x, s, Config.data.ba ) THEN Fatal( 'Test53: MkCard failed' ) END;
  WrStr( ' x = ' ); WrHex( x ); WrLn();

  IO.WrStr( 'Test53: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test53;




PROCEDURE Add( s-, t-: ARRAY OF CHAR );
VAR
  x, y: TCardMax;
  r: Config.TNumStr;
BEGIN
  IF ~ LCC.MkCard( x, s, Config.data.ba ) THEN Fatal( 'Add: Invalid 1st argument' ) END;
  IF ~ LCC.MkCard( y, t, Config.data.ba ) THEN Fatal( 'Add: Invalid 2nd argument' ) END;
  IF ~ LC.Inc( x, y ) THEN Fatal( 'Add: Result too large' ) END;
  IF ~ LCC.MkStr( r, x, Config.data.br ) THEN Fatal( 'Add: Result string too short' ) END;
  WrStr( s ); WrStr( ' + ' ); WrStr( t ); WrStr( ' = ' ); WrStr( r ); WrLn();
END Add;

PROCEDURE Sub( s-, t-: ARRAY OF CHAR );
VAR
  x, y: TCardMax;
  r: Config.TNumStr;
BEGIN
  IF ~ LCC.MkCard( x, s, Config.data.ba ) THEN Fatal( 'Sub: Invalid 1st argument' ) END;
  IF ~ LCC.MkCard( y, t, Config.data.ba ) THEN Fatal( 'Sub: Invalid 2nd argument' ) END;
  IF LC.Cmp( x, y ) < 0 THEN Fatal( 'Sub: Result not cardinal' ) END;
  IF ~ LC.Dec( x, y ) THEN Fatal( 'Sub: Result too large' ) END;
  IF ~ LCC.MkStr( r, x, Config.data.br ) THEN Fatal( 'Sub: Result string too short' ) END;
  WrStr( s ); WrStr( ' - ' ); WrStr( t ); WrStr( ' = ' ); WrStr( r ); WrLn();
END Sub;

PROCEDURE Mul( s-, t-: ARRAY OF CHAR );
VAR
  x, y, z: TCardMax;
  r: Config.TNumStr;
BEGIN
  IF ~ LCC.MkCard( x, s, Config.data.ba ) THEN Fatal( 'Mul: Invalid 1st argument' ) END;
  IF ~ LCC.MkCard( y, t, Config.data.ba ) THEN Fatal( 'Mul: Invalid 2nd argument' ) END;
  IF ~ LC.Mul( x, y, z ) THEN Fatal( 'Mul: Result too large' ) END;
  IF ~ LCC.MkStr( r, z, Config.data.br ) THEN Fatal( 'Mul: Result string too short' ) END;
  WrStr( s ); WrStr( ' * ' ); WrStr( t ); WrStr( ' = ' ); WrStr( r ); WrLn();
END Mul;

PROCEDURE Div( s-, t-: ARRAY OF CHAR );
VAR
  x, y, z, m: TCardMax;
  r: Config.TNumStr;
BEGIN
  IF ~ LCC.MkCard( x, s, Config.data.ba ) THEN Fatal( 'Div: Invalid 1st argument' ) END;
  IF ~ LCC.MkCard( y, t, Config.data.ba ) THEN Fatal( 'Div: Invalid 2nd argument' ) END;
  IF ~ LC.Div( x, y, z, m ) THEN Fatal( 'Div: Division by zero' ) END;
  IF ~ LCC.MkStr( r, z, Config.data.br ) THEN Fatal( 'Div: Result string too short' ) END;
  WrStr( s ); WrStr( ' DIV ' ); WrStr( t ); WrStr( ' = ' ); WrStr( r ); WrLn();
END Div;

PROCEDURE Mod( s-, t-: ARRAY OF CHAR );
VAR
  x, y, z, m: TCardMax;
  r: Config.TNumStr;
BEGIN
  IF ~ LCC.MkCard( x, s, Config.data.ba ) THEN Fatal( 'Mod: Invalid 1st argument' ) END;
  IF ~ LCC.MkCard( y, t, Config.data.ba ) THEN Fatal( 'Mod: Invalid 2nd argument' ) END;
  IF ~ LC.Div( x, y, z, m ) THEN Fatal( 'Mod: Division by zero' ) END;
  IF ~ LCC.MkStr( r, m, Config.data.br ) THEN Fatal( 'Mod: Result string too short' ) END;
  WrStr( s ); WrStr( ' MOD ' ); WrStr( t ); WrStr( ' = ' ); WrStr( r ); WrLn();
END Mod;



PROCEDURE Test60();
VAR
  x, y, z: Types.TLngCard;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test60: begin' ); IO.WrLn();
  t := Now();

  x := 91827364H;
  y := 12345678H;
  IF ~ LC.Add( x, y, z ) THEN Fatal( 'Test60: Add failed' ) END;
  WrStr( ' ' ); WrHex( x ); WrStr( ' + ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();

  IO.WrStr( 'Test60: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test60;

PROCEDURE Test61();
CONST
  cMax = 0FFFFFFFFH;
VAR
  x, y: Types.TCard;
  z: Types.TLngCard;
  c: CARDINAL;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test61: begin' ); IO.WrLn();
  t := Now();

  RNG.SetSeed( 12345 );
  FOR c := 0 TO cMax DO
    x := RNG.Read( 0 );
    y := RNG.Read( 0 );
    IF ~ LC.Add( x, y, z ) THEN Fatal( 'Test61: Add failed' ) END;
    IF x + y # z THEN
      WrStr( ' x = ' ); WrHex( x ); WrLn();
      WrStr( ' y = ' ); WrHex( y ); WrLn();
      WrStr( ' z = ' ); WrHex( z ); WrLn();
      Fatal( 'Test61: Wrong result' );
    END;
    IF c MOD 20000000H = 0 THEN
      WrHex( c ); WrStr( ': ' ); WrHex( x ); WrStr( ' + ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();
    END;
  END;

  IO.WrStr( 'Test61: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test61;

PROCEDURE Test63();
CONST
  cMax = 0FFFFFFFFH;
VAR
  x, y, z: Types.TCard;
  c: CARDINAL;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test63: begin' ); IO.WrLn();
  t := Now();

  RNG.SetSeed( 12345 );
  FOR c := 0 TO cMax DO
    x := RNG.Read( 0 );
    y := RNG.Read( 0 );
    IF x < y THEN z := x; x := y; y := z END;
    IF ~ LC.Sub( x, y, z ) THEN Fatal( 'Test63: Sub failed' ) END;
    IF x - y # z THEN
      WrStr( ' x = ' ); WrHex( x ); WrLn();
      WrStr( ' y = ' ); WrHex( y ); WrLn();
      WrStr( ' z = ' ); WrHex( z ); WrLn();
      Fatal( 'Test63: Wrong result' );
    END;
    IF c MOD 20000000H = 0 THEN
      WrHex( c ); WrStr( ': ' ); WrHex( x ); WrStr( ' - ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();
    END;
  END;

  IO.WrStr( 'Test63: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test63;

PROCEDURE Test65();
CONST
  cMax = 0FFFFFFFFH;
VAR
  x, y: Types.TCard;
  z: Types.TLngCard;
  c: CARDINAL;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test65: begin' ); IO.WrLn();
  t := Now();

  RNG.SetSeed( 12345 );
  FOR c := 0 TO cMax DO
    x := RNG.Read( 0 );
    y := RNG.Read( 0 );
    IF ~ LC.Mul( x, y, z ) THEN Fatal( 'Test65: Mul failed' ) END;
    IF x * y # z THEN
      WrStr( ' x = ' ); WrHex( x ); WrLn();
      WrStr( ' y = ' ); WrHex( y ); WrLn();
      WrStr( ' z = ' ); WrHex( z ); WrLn();
      Fatal( 'Test65: Wrong result' );
    END;
    IF c MOD 10000000H = 0 THEN
      WrHex( c ); WrStr( ': ' ); WrHex( x ); WrStr( ' * ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();
    END;
  END;

  IO.WrStr( 'Test65: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test65;

PROCEDURE Test66();
CONST
  cMax = 0FFFFFFFFH;
VAR
  x: Types.TCard;
  y: Types.TLngCard;
  c: CARDINAL;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test66: begin' ); IO.WrLn();
  t := Now();

  RNG.SetSeed( 12345 );
  FOR c := 0 TO cMax DO
    x := RNG.Read( 0 );
    y := x;
    IF ~ LC.Mpl( y, x ) THEN Fatal( 'Test66: Mpl failed' ) END;
    IF x * x # y THEN
      WrStr( ' x = ' ); WrHex( x ); WrLn();
      WrStr( ' y = ' ); WrHex( y ); WrLn();
      Fatal( 'Test66: Wrong result' );
    END;
    IF c MOD 10000000H = 0 THEN
      WrHex( c ); WrStr( ': ' ); WrHex( x ); WrStr( ' * ' ); WrHex( x ); WrStr( ' = ' ); WrHex( y ); WrLn();
    END;
  END;

  IO.WrStr( 'Test66: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test66;

PROCEDURE Test67();
CONST
  cMax = 0FFFFFFFFH;
VAR
  x: Types.TCard;
  y: Types.TLngCard;
  c: CARDINAL;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test67: begin' ); IO.WrLn();
  t := Now();

  RNG.SetSeed( 12345 );
  FOR c := 0 TO cMax DO
    x := RNG.Read( 0 );
    y := x;
    IF ~ LC.Sqr( y ) THEN Fatal( 'Test67: Sqr failed' ) END;
    IF x * x # y THEN
      WrStr( ' x = ' ); WrHex( x ); WrLn();
      WrStr( ' y = ' ); WrHex( y ); WrLn();
      Fatal( 'Test67: Wrong result' );
    END;
    IF c MOD 10000000H = 0 THEN
      WrHex( c ); WrStr( ': ' ); WrHex( x ); WrStr( ' * ' ); WrHex( x ); WrStr( ' = ' ); WrHex( y ); WrLn();
    END;
  END;

  IO.WrStr( 'Test67: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test67;


PROCEDURE Test70();
VAR
  x: Types.TLngCard;
  y: Types.TShtCard;
  z: TCard03;
  r: TCard02;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test70: begin' ); IO.WrLn();
  t := Now();

  x := 0FF0001H;
  y := 0FFH;
  IF ~ LC.Div( x, y, z, r ) THEN Fatal( 'Test70: Div failed' ) END;
  WrStr( '  ' ); WrHex( x ); WrStr( ' DIV ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();
  WrStr( '  ' ); WrHex( x ); WrStr( ' MOD ' ); WrHex( y ); WrStr( ' = ' ); WrHex( r ); WrLn();

  IO.WrStr( 'Test70: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test70;

PROCEDURE Test71();
VAR
  x: Types.TLngCard;
  y: Types.TCard;
  z: Types.TLngCard;
  r: Types.TCard;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test71: begin' ); IO.WrLn();
  t := Now();

  FOR x := 0 TO 0FFFFFFFFH DO
    IF x MOD 400H = 0 THEN WrHex( x ); WrLn(); END;
    FOR y := 1 TO 0FFFFH DO
      IF ~ LC.Div( x, y, z, r ) THEN Fatal( 'Test71: Div failed' ) END;
      IF ( z # x DIV y ) OR ( r # x MOD y ) THEN
        WrStr( ' x = ' ); WrHex( x ); WrLn();
        WrStr( ' y = ' ); WrHex( y ); WrLn();
        WrStr( ' z = ' ); WrHex( z ); WrLn();
        WrStr( ' r = ' ); WrHex( r ); WrLn();
        Fatal( 'Test71: Wrong result' );
      END;
    END;
  END;

  IO.WrStr( 'Test71: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test71;

PROCEDURE Test72();
CONST
  cMax = 1000000H - 1;
VAR
  x: Types.TLngCard;
  y: Types.TCard;
  z: Types.TLngCard;
  r: Types.TCard;
  c: CARDINAL;
  t: Tmr0.TTicks;
BEGIN
  IO.WrStr( 'Test72: begin' ); IO.WrLn();
  t := Now();

  RNG.SetSeed( 12345 );
  FOR c := 0 TO cMax DO
    x := RNG.Read( 0 ) * 10000H + RNG.Read( 0 );
    y := RNG.Read( 0FFFFH ) + 1;
    IF ~ LC.Div( x, y, z, r ) THEN Fatal( 'Test72: Div failed' ) END;
    IF ( x DIV y # z ) OR ( x MOD y # r ) THEN
      WrStr( ' x = ' ); WrHex( x ); WrLn();
      WrStr( ' y = ' ); WrHex( y ); WrLn();
      WrStr( ' z = ' ); WrHex( z ); WrLn();
      WrStr( ' r = ' ); WrHex( r ); WrLn();
      Fatal( 'Test72: Wrong result' );
    END;
    IF c MOD 100000H = 0 THEN
      WrHex( c ); WrStr( ': ' ); WrHex( x ); WrStr( ' DIV ' ); WrHex( y ); WrStr( ' = ' ); WrHex( z ); WrLn();
      WrHex( c ); WrStr( ': ' ); WrHex( x ); WrStr( ' MOD ' ); WrHex( y ); WrStr( ' = ' ); WrHex( r ); WrLn();
    END;
  END;

  IO.WrStr( 'Test72: end ' ); IO.WrLngCard( Tmr0.Diff( t, Now() ), 1 ); IO.WrStr( 'ms' ); IO.WrLn();
END Test72;


BEGIN
  IF ( Config.data.ba < LCC.bMin ) OR ( Config.data.ba > LCC.bMax ) THEN Fatal( 'LrgCards: Invalid argument base' ) END;
  IF ( Config.data.br < LCC.bMin ) OR ( Config.data.br > LCC.bMax ) THEN Fatal( 'LrgCards: Invalid result base' ) END;
  CASE Config.data.act OF
  | Config.aTst: Test10(); Test11(); Test20(); Test21(); Test30(); Test40(); Test51(); Test52();
  | Config.aAdd: Add( Config.data.arg, Config.data.brg );
  | Config.aSub: Sub( Config.data.arg, Config.data.brg );
  | Config.aMul: Mul( Config.data.arg, Config.data.brg );
  | Config.aDiv: Div( Config.data.arg, Config.data.brg );
  | Config.aMod: Mod( Config.data.arg, Config.data.brg );
  ELSE
    Fatal( 'LrgCards: Action not implemented' );
  END;
END LrgCards.
